﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace XamDataChartHighVolumeDNF
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        List<DataPoint> Data { get; set; }
        Random r = new Random();
        public MainWindow()
        {
            InitializeComponent();
            this.Data = new List<DataPoint>();
        }

        private void bindDataBtn_Click(object sender, RoutedEventArgs e)
        {
            Stopwatch watch = new Stopwatch();
            watch.Start();

            this.DataContext = Data;

            watch.Stop();

            Debug.WriteLine(watch.ElapsedMilliseconds + " milliseconds to bind data");
        }

        
        private void createDataBtn_Click(object sender, RoutedEventArgs e)
        {
            Stopwatch watch = new Stopwatch();
            watch.Start();

            double value = 300;
            for(int i=0; i<500000; i++)
            {
                DataPoint point = new DataPoint() { Index = i };
                double num = r.NextDouble();
                
                if(r.NextDouble() > .5)
                {
                    value = value + (500 * num);
                }
                else
                {
                    value = value - (500 * num);
                }
                
                point.Value = value;

                this.Data.Add(point);
            }

            watch.Stop();
            Debug.WriteLine(watch.ElapsedMilliseconds + " milliseconds to generate data");
        }
    }

    public class DataPoint
    {
        public int Index { get; set; }
        public double Value { get; set; }
    }
}
